var Panels = (function (){
        return {execCommand: function (commandName, waitForVA, doneFunction, failFunction, doneFunctionTag)
        {
          var sUrl;

          if (waitForVA)
              sUrl = "va_command_execwait~|~" + commandName;
          else
              sUrl = "va_command_exec~|~" + commandName;
              
          if (doneFunctionTag)
             sUrl += "va_command_exec~|~" + commandName + '~|~' + doneFunctionTag.toString();

          var asyncCall = true;
          if (!doneFunction && !failFunction)
              asyncCall = false;

          var request = $.ajax({
                url: sUrl,
                type: "GET",            
                dataType: "html",
                async:asyncCall
            });

          if (doneFunction)
              request.done(doneFunction);

            if (failFunction)
                request.fail(failFunction);

        },
        
        getText: function (variableName) {
            var textVal = $.ajax({
                type: "GET",
                url: "va_getvar~|~text~|~" + variableName,
                dataType: "html",
                async: false
            }).responseText;

            if (textVal == "Not Set")
                return null;
            else
                return textVal;
        },

        setText: function (variableName, value) {
            if (!value)
                value = '~~not set~~';

            $.ajax({
                type: "GET",
                url: "va_setvar~|~text~|~" + variableName + "~|~" + value,
                dataType: "html",
                async: false
            });
        },

        getBoolean: function (variableName) {
            var boolVal = $.ajax({
                type: "GET",
                url: "va_getvar~|~bool~|~" + variableName,
                dataType: "html",
                async: false
            }).responseText;

            if (boolVal == "Not Set")
                return null;
            else
                return boolVal == "True";
        },

        setBoolean: function (variableName, value) {
            var sReturn;
            if (value == false)
                sReturn = 'false';
            else {
                if (value == true)
                    sReturn = 'true';
                else
                    sReturn = 'null';
            }

            $.ajax({
                type: "GET",
                url: "va_setvar~|~bool~|~" + variableName + "~|~" + sReturn,
                dataType: "html",
                async: false
            });
        },

        getInt: function (variableName) {
            var intVal = $.ajax({
                type: "GET",
                url: "va_getvar~|~int~|~" + variableName,
                dataType: "html",
                async: false
            }).responseText;

            if (intVal == "Not Set")
                return null;
            else
                return parseInt(intVal);
        },

        setInt: function (variableName, value) {
            var sReturn;
            if (value)
                sReturn = value.toString();
            else
                sReturn = 'null';

            $.ajax({
                type: "GET",
                url: "va_setvar~|~int~|~" + variableName + "~|~" + sReturn,
                dataType: "html",
                async: false
            });
        },

        getSmallInt: function (variableName) {
            var intVal = $.ajax({
                type: "GET",
                url: "va_getvar~|~small~|~" + variableName,
                dataType: "html",
                async: false
            }).responseText;

            if (intVal == "Not Set")
                return null;
            else
                return parseInt(intVal);
        },

        setSmallInt: function (variableName, value) {
            var sReturn;
            if (value)
                sReturn = value.toString();
            else
                sReturn = 'null';

            $.ajax({
                type: "GET",
                url: "va_setvar~|~small~|~" + variableName + "~|~" + sReturn,
                dataType: "html",
                async: false
            });
        },

        getDecimal: function (variableName) {
            var decVal = $.ajax({
                type: "GET",
                url: "va_getvar~|~dec~|~" + variableName,
                dataType: "html",
                async: false
            }).responseText;

            if (decVal == "Not Set")
                return null;
            else
                return parseFloat(decVal);
        },

        setDecimal: function (variableName, value) {
            var sReturn;
            if (value)
                sReturn = value.toString();
            else
                sReturn = 'null';

            $.ajax({
                type: "GET",
                url: "va_setvar~|~dec~|~" + variableName + "~|~" + sReturn,
                dataType: "html",
                async: false
            });
        },

        getDate: function (variableName) {
            var dtVal = $.ajax({
                type: "GET",
                url: "va_getvar~|~date~|~" + variableName,
                dataType: "html",
                async: false
            }).responseText;

            alert(dtVal);

            if (dtVal == "Not Set")
                return null;
            else
                return new Date(Date.parse(dtVal));
        },

        setDate: function (variableName, value) {
            var sReturn;
            if (value)
                sReturn = value.toString();
            else
                sReturn = 'null';

            $.ajax({
                type: "GET",
                url: "va_setvar~|~date~|~" + variableName + "~|~" + sReturn,
                dataType: "html",
                async: false
            });
        }};})();